package quq.ots.example.resource;

import java.sql.SQLException;

import javax.sql.XAConnection;
import javax.transaction.xa.XAException;
import javax.transaction.xa.XAResource;

import javax.transaction.xa.Xid;

import org.omg.CosTransactions.HeuristicCommit;
import org.omg.CosTransactions.HeuristicHazard;
import org.omg.CosTransactions.HeuristicMixed;
import org.omg.CosTransactions.HeuristicRollback;
import org.omg.CosTransactions.NotPrepared;
import org.omg.CosTransactions.Vote;
import org.omg.CosTransactions.otid_t;

import oracle.jdbc.xa.OracleXid;
import oracle.jdbc.xa.client.*;

public class OracleResource extends org.omg.CosTransactions.ResourcePOA
{

	OracleXAResource xaRes;
	otid_t otid;
	Xid xid ;
	public XAConnection xaConn;
	public OracleResourceManager rm;

	//public OracleResource(OracleResourceManager rm, otid_t otid, byte [] gid, byte [] bqid) {
	public OracleResource(OracleResourceManager rm, otid_t otid, byte[] rmid) {
		super();
		this.rm = rm;
		/*

		this.otid = otid;

		System.out.println("otid_t formatID:"+otid.formatID);
		System.out.println("otid_t tid byte[]:"+otid.tid);
		System.out.println("otid_t tid lenth:"+otid.tid.length);
		System.out.println("otid_t tid string:"+new String(otid.tid));
		System.out.println("otid_t bqual_length:"+otid.bqual_length);

		*/
		byte[] gId = null;
		byte[] bId = null;
		try {
			
			int gtrid_length = otid.tid.length - otid.bqual_length;
			int bqual_length = otid.bqual_length;

			

				gId= new byte[otid.tid.length];
				
				System.arraycopy(otid.tid, 0, gId, 0, otid.tid.length);

			
			

			//System.out.println("OracleXid formatID:"+otid.formatID);
			System.out.println("OracleXid gID:"+new String(gId));
	
			
			this.xid = new OracleXid(otid.formatID, gId, rmid);
			System.out.println("OracleXid Created:"+xid);
			//System.out.println("OracleXid formatID:"+xid.getFormatId());
			System.out.println("OracleXid gID:"+new String(xid.getGlobalTransactionId()));
			System.out.println("OracleXid bID:"+new String(xid.getBranchQualifier()));
		} catch (XAException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
			System.err.println("Create OracleXid Error:"+e1.getMessage());
		}

		try {
			xaConn= rm.xaDs.getXAConnection();
			if(xaConn == null)
			{
				System.err.println("getXAConnection is Null");			
			}
			else
			{
				System.out.println("getXAConnection is OK");
				this.xaRes=(OracleXAResource)xaConn.getXAResource();

			}
			
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			System.err.println("Get getXAResource Error:"+e.getMessage());
		}

		try {
			System.err.println("Start to start XA Transaction XID["+xid+"]");
			
			xaRes.start(xid, javax.transaction.xa.XAResource.TMNOFLAGS);
			xaRes.setTransactionTimeout(0);
			System.err.println("start XA Transaction Sucessfully XID["+xid+"]");
		} catch (XAException e) {
			System.err.println("start XA Transaction Failure XID["+xid+"],Msg["+e.getMessage()+"]");
			e.printStackTrace();
			
		}
	}



	
	public void commit() throws NotPrepared, HeuristicHazard, HeuristicMixed,
			HeuristicRollback {

		try {
			System.err.println("Start to commit XA Transaction XID["+xid+"]");
			xaRes.commit(xid, false);
			System.err.println("Commit XA Transaction Sucessfully XID["+xid+"]");
		} catch (XAException e) {
			System.err.println("Commit XA Transaction Failure XID["+xid+"],Msg["+e.getMessage()+"]");
			e.printStackTrace();
		}
	}

	
	public void commit_one_phase() throws HeuristicHazard {
		System.err.println("Start to commit_one_phase XA Transaction XID["+xid+"]");
	}

	
	public void forget() {
		try {
			System.err.println("Start to forget XA Transaction XID["+xid+"]");
			xaRes.forget(xid);
			System.err.println("forget XA Transaction Sucessfully XID["+xid+"]");
		} catch (XAException e) {
			System.err.println("forget XA Transaction Failure XID["+xid+"],Msg["+e.getMessage()+"]");
			e.printStackTrace();
		}

	}


	public Vote prepare() throws HeuristicHazard, HeuristicMixed {
		int ret = 0;
		
		try {
			System.err.println("Start to end XA Transaction XID["+xid+"]");
			xaRes.end(xid,javax.transaction.xa.XAResource.TMSUCCESS);
			System.err.println("end XA Transaction Sucessfully XID["+xid+"]");
		} catch (XAException e) {
			System.err.println("end XA Transaction Failure XID["+xid+"],Msg["+e.getMessage()+"]");
			e.printStackTrace();
			
		}		
		try {
			System.err.println("start to prepare XA Transaction XID["+xid.getBranchQualifier()+"]");
			ret = xaRes.prepare(xid);
			System.err.println("prepare XA Transaction Sucessfully XID["+xid.getBranchQualifier()+"],Ret="+ret);
		} catch (XAException e) {
			System.err.println("prepare XA Transaction Failure XID["+xid.getBranchQualifier()+"],Msg["+e.getMessage()+"]");
			e.printStackTrace();
			return Vote.VoteRollback;
		}
		
		//Vote voteRet=new Vote();
		switch (ret) {
		case XAResource.XA_OK:
			return Vote.VoteCommit;
		case XAResource.XA_RDONLY:
			return Vote.VoteReadOnly;
		default:
			return Vote.VoteRollback;
		}
	}


	public void rollback() throws HeuristicHazard, HeuristicMixed,
			HeuristicCommit {
		try {
			System.err.println("start to rollback XA Transaction XID["+xid+"]");
			xaRes.rollback(xid);
			System.err.println("rollback XA Transaction Sucessfully XID["+xid+"]");
		} catch (XAException e) {
			System.err.println("rollback XA Transaction Failure XID["+xid+"],Msg["+e.getMessage()+"]");
			e.printStackTrace();
		}

	}
	
}
